package djmil.cordacheckers;

import net.corda.v5.ledger.utxo.Command;
import net.corda.v5.ledger.utxo.ContractState;
import net.corda.v5.ledger.utxo.transaction.UtxoLedgerTransaction;

public class UtxoLedgerTransactionUtil {
    private final UtxoLedgerTransaction trx;

    public UtxoLedgerTransactionUtil(UtxoLedgerTransaction trx) {
        this.trx = trx;
    }

    public <T extends Command> T getSingleCommand(Class<T> clazz) {
        return trx.getCommands(clazz)
            .stream()
            .reduce( (a, b) -> {throw new IllegalStateException(trx.getId() +EXPECTED_SINGLE_CLAZZ +clazz);} )
            .get();
    }

    public <T extends ContractState> T getSingleReferenceState(Class<T> clazz) {
        return trx.getReferenceStates(clazz)
            .stream()
            .reduce( (a, b) -> {throw new IllegalStateException(trx.getId() +EXPECTED_SINGLE_CLAZZ +clazz);} )
            .get();
    }

    public <T extends ContractState> T getSingleInputState(Class<T> clazz) {
        return trx.getInputStates(clazz)
            .stream()
            .reduce( (a, b) -> {throw new IllegalStateException(trx.getId() +EXPECTED_SINGLE_CLAZZ +clazz);} )
            .get();
    }

    public <T extends ContractState> T getSingleOutputState(Class<T> clazz) {
        return trx.getOutputStates(clazz)
            .stream()
            .reduce( (a, b) -> {throw new IllegalStateException(trx.getId() +EXPECTED_SINGLE_CLAZZ +clazz);} )
            .get();
    }

    private static String EXPECTED_SINGLE_CLAZZ = ": expected single ";
}
